<?
/*  Newsportal NNTP<->HTTP Gateway
 *  Version: 0.34
 *  Download: http://florian-amrhein.de/newsportal
 *
 *  Copyright (C) 2002-2004 Florian Amrhein
 *  E-Mail: florian.amrhein@gmx.de
 *  Web: http://florian-amrhein.de
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/*
 * the name and the description of a newsgroup
 */
class newsgroupType {
  var $name;
  var $description;
  var $count;
  var $text;
}

/*
 * Stores a complete article:
 * - The parsed Header as an headerType
 * - The bodies and attachments as an array of array of lines
 */
class messageType {
  var $header;
  var $body;
}



/*
 * Stores the Header of an article
 */
class headerType {
  var $number; // the Number of an article inside a group
  var $id;     // Message-ID
  var $from;   // eMail of the author
  var $name;   // Name of the author
  var $subject; // the subject
  var $newsgroups;  // the Newsgroups where the article belongs to
  var $followup;
  var $date;         // timestamp of the article
  var $date_thread;  // timestamp of the newest article in the thread
  var $organization;
  var $xnoarchive;
  var $references;     // all references to the article
  var $bestreference;  // nearest reference found
  var $content_transfer_encoding;
  var $mime_version;
  var $content_type;   // array, Content-Type of the Body (Index=0) and the
                       // Attachments (Index>0)
  var $content_type_charset;  // like content_type
  var $content_type_name;     // array of the names of the attachments
  var $content_type_boundary; // The boundary of an multipart-article.
  var $content_type_format;   // array, is the body in flowed format?
  var $answers;    // which articles are followups of this article?
  var $isAnswer;   // is the article an answer to an other article?
  var $username;
  var $user_agent;
  var $isReply;    // has this article "Re: " at the beginning of the subject?
  var $threadsize; // number of articles in this thread
}

/*
 * opens the connection to the NNTP-Server
 *
 * $server: adress of the NNTP-Server
 * $port: port of the server
 */
function nntp_open($nserver=0,$nport=0) {
  global $text_error,$server_auth_user,$server_auth_pass,$readonly;
  global $server,$port;
  $authorize=((isset($server_auth_user)) && (isset($server_auth_pass)) &&
              ($server_auth_user != ""));
  if ($nserver==0) $nserver=$server;
  if ($nport==0) $nport=$port;
  $ns=@fsockopen($nserver,$nport);
  $weg=line_read($ns);  // kill the first line
  if (substr($weg,0,2) != "20") {
    echo "<p>".$text_error["error:"].$weg."</p>";
    fclose($ns);
    $ns=false;
  } else {
    if ($ns != false) {
      fputs($ns,"MODE reader\r\n");
      $weg=line_read($ns);  // and once more
      if ((substr($weg,0,2) != "20") && 
          ((!$authorize) || ((substr($weg,0,3) != "480") && ($authorize)))) {
        echo "<p>".$text_error["error:"].$weg."</p>";
        fclose($ns);
        $ns=false;
      }
    }
    if ((isset($server_auth_user)) && (isset($server_auth_pass)) &&
        ($server_auth_user != "")) {
      fputs($ns,"AUTHINFO USER $server_auth_user\r\n");
      $weg=line_read($ns);
      fputs($ns,"AUTHINFO PASS $server_auth_pass\r\n"); 
      $weg=line_read($ns);
      if (substr($weg,0,3) != "281") {
        echo "<p>".$text_error["error:"]."</p>";
        echo "<p>".$text_error["auth_error"]."</p>";
      }
    }
  }
  if ($ns==false) echo "<p>".$text_error["connection_failed"]."</p>";
  return $ns;
}

/*
 * Close a NNTP connection
 *
 * $ns: the handle of the connection
 */
function nntp_close(&$ns) {
  if ($ns != false) {
    fputs($ns,"QUIT\r\n");
    fclose($ns);
  }
}

/*
 * Validates an email adress
 *
 * $address: a string containing the email-address to be validated
 *
 * returns true if the address passes the tests, false otherwise.
 */
function validate_email($address)
{
  global $validate_email;
  $return=true;
  if (($validate_email >= 1) && ($return == true))
    $return = (ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_A-z{|}~]+'.'@'.
               '[-!#$%&\'*+\\/0-9=?A-Z^_A-z{|}~]+\.'.
               '[-!#$%&\'*+\\./0-9=?A-Z^_A-z{|}~]+$',$address));
  if (($validate_email >= 2) && ($return == true)) {
    $addressarray=address_decode($address,"garantiertungueltig");
    $return=checkdnsrr($addressarray[0]["host"],"MX");
    if (!$return) $return=checkdnsrr($addressarray[0]["host"],"A");
  }
  return($return);
}

/*
 * decodes a block of 7bit-data in uuencoded format to it's original
 * 8bit format.
 * The headerline containing filename and permissions doesn't have to
 * be included.
 * 
 * $data: The uuencoded data as a string
 *
 * returns the 8bit data as a string
 *
 * Note: this function is very slow and doesn't recognize incorrect code.
 */
function uudecode_line($line) {
  $data=substr($line,1);
  $length=ord($line[0])-32;
  $decoded="";
  for ($i=0; $i<(strlen($data)>>2); $i++) {
    $pack=substr($data,$i<<2,4);
    $upack="";
    $bitmaske=0;
    for ($o=0; $o<4; $o++) {
      $g=((ord($pack[3-$o])-32));
      if ($g==64) $g=0;
      $bitmaske=$bitmaske | ($g << (6*$o));
    }
    $schablone=255;
    for ($o=0; $o<3; $o++) {
      $c=($bitmaske & $schablone) >> ($o << 3);
      $schablone=($schablone << 8);
      $upack=chr($c).$upack;
    }
    $decoded.=$upack;
  }
  $decoded=substr($decoded,0,$length);
  return $decoded;
}

/*
 * decodes uuencoded Attachments.
 *
 * $data: the encoded data
 *
 * returns the decoded data
 */
function uudecode($data) {
  $d=explode("\n",$data);
  $u="";
  for ($i=0; $i<count($d)-1; $i++)
    $u.=uudecode_line($d[$i]);
  return $u;
}

/*
 * returns the mimetype of an filename
 *
 * $name: the complete filename of a file
 *
 * returns a string containing the mimetype
 */
function get_mimetype_by_filename($name) {
  $ending=strtolower(strrchr($name,"."));
  switch($ending) {
    case ".jpg":
    case ".jpeg":
      $type="image/jpeg";
      break;
    case ".gif":
      $type="image/gif";
      break;
    case ".png":
      $type="image/png";
      break;
    case ".bmp":
      $type="image/bmp";
      break;
    default:
      $type="text/plain";
  }
  return $type;
}

/*
 * Shows the little menu on the thread.php where you can select the
 * different pages with the articles on it
 */
function showPageSelectMenu($group,$article_count,$first) {
  global $articles_per_page,$file_thread,$file_framethread,$name;
  $pages=ceil($article_count / $articles_per_page);
  if ($article_count > $articles_per_page)
    for ($i = 0; $i < $pages; $i++) {
      echo '[';
      if ($first != $i*$articles_per_page+1)
        echo '<a href="'.$file_thread.'?group='.$group.
             '&amp;first='.($i*$articles_per_page+1).'&amp;last='.
             ($i+1)*$articles_per_page.'">';
      echo ($i*$articles_per_page+1).'-';
      if ($i == $pages-1) {
        echo $article_count;
      } else {
        echo ($i+1)*$articles_per_page;
      }
      if ($first != $i*$articles_per_page+1)
        echo '</a>';
      echo '] ';
    }
}


/*
 * Test, if the access to a group is allowed. This is true, if $testgroup is
 * false or the groupname is in groups.txt
 *
 * $groupname: name of the group to be checked
 *
 * returns true, if access is allowed
 */
function testGroup($groupname) {
  global $testgroup;
  if ($testgroup) {
    $gf=fopen("groups.txt","r");
    while (!feof($gf)) {
      $read=trim(line_read($gf));
      $pos=strpos($read," ");
      if ($pos != false) {
        if (substr($read,0,$pos)==trim($groupname)) return true;
      } else {
        if ($read == trim($groupname)) return true;
      }
    }
    fclose($gf);
    return false;
  } else {
    return true;
  }
}

function testGroups($newsgroups) {
  $groups=explode(",",$newsgroups);
  $count=count($groups);
  $return="";
  $o=0;
  for ($i=0; $i<$count; $i++) {
    if (testgroup($groups[$i])) {
      if ($o>0) $return.=",";
      $o++;
      $return.=$groups[$i];
    }
  }
  return($return);
}

/*
 * read one line from the NNTP-server
 */
function line_read(&$ns) {
  if ($ns != false) {
    $t=str_replace("\n","",str_replace("\r","",fgets($ns,1200)));
    return $t;
  }
}

/*
 * Split an internet-address string into its parts. An address string could
 * be for example:
 * - user@host.domain (Realname)
 * - "Realname" <user@host.domain>
 * - user@host.domain
 *
 * The address will be split into user, host (incl. domain) and realname
 *
 * $adrstring: The string containing the address in internet format
 * $defaulthost: The name of the host which should be returned if the
 *               address-string doesn't contain a hostname.
 *
 * returns an hash containing the fields "mailbox", "host" and "personal"
 */
function address_decode($adrstring,$defaulthost) {
  $parsestring=trim($adrstring);
  $len=strlen($parsestring);
  $at_pos=strpos($parsestring,'@');     // find @
  $ka_pos=strpos($parsestring,"(");     // find (
  $kz_pos=strpos($parsestring,')');     // find )
  $ha_pos=strpos($parsestring,'<');     // find <
  $hz_pos=strpos($parsestring,'>');     // find >
  $space_pos=strpos($parsestring,')');  // find ' '
  $email="";
  $mailbox="";
  $host="";
  $personal="";
  if ($space_pos != false) {
    if (($ka_pos != false) && ($kz_pos != false)) {
      $personal=substr($parsestring,$ka_pos+1,$kz_pos-$ka_pos-1);
      $email=trim(substr($parsestring,0,$ka_pos-1));
    }
  } else {
    $email=$adrstring;
  }
  if (($ha_pos != false) && ($hz_pos != false)) {
    $email=trim(substr($parsestring,$ha_pos+1,$hz_pos-$ha_pos-1));
    $personal=substr($parsestring,0,$ha_pos-1);
  }
  if ($at_pos != false) {
    $mailbox=substr($email,0,strpos($email,'@'));
    $host=substr($email,strpos($email,'@')+1);
  } else {
    $mailbox=$email;
    $host=$defaulthost;
  }
  $personal=trim($personal);
  if (substr($personal,0,1) == '"') $personal=substr($personal,1);
  if (substr($personal,strlen($personal)-1,1) == '"')
    $personal=substr($personal,0,strlen($personal)-1);
  $result["mailbox"]=trim($mailbox);
  $result["host"]=trim($host);
  if ($personal!="") $result["personal"]=$personal;
  $complete[]=$result;
  return ($complete);
}

/*
 * Read the groupnames from groups.txt, and get additional informations
 * of the groups from the newsserver
 */
function groups_read($server,$port) {
  global $gl_age;
  $ns=nntp_open($server,$port);
  if ($ns == false) return false;
  $gf=fopen("groups.txt","r");
  // if we want to mark groups with new articles with colors, wie will later
  // need the format of the overview
  $overviewformat=read_overviewformat($ns);
  while (!feof($gf)) {
    $gruppe=new newsgroupType;
    $tmp=trim(line_read($gf));
    if(substr($tmp,0,1)==":") {
      $gruppe->text=substr($tmp,1);
      $newsgroups[]=$gruppe;  
    } else {
      // is there a description in groups.txt?
      $pos=strpos($tmp," ");
      if ($pos != false) {
        // yes.
        $gruppe->name=substr($tmp,0,$pos);
        $desc=substr($tmp,$pos);
      } else {
        // no, get it from the newsserver.
        $gruppe->name=$tmp;
        fputs($ns,"XGTITLE $gruppe->name\r\n");
        $response=line_read($ns);
        if (strcmp(substr($response,0,3),"282") == 0) {
          $neu=line_read($ns);
          do {
            $response=$neu;
            if ($neu != ".") $neu=line_read($ns);
          } while ($neu != ".");
          $desc=strrchr($response,"\t");
          if (strcmp($response,".") == 0) {
            $desc="-";
          }
        } else {
          $desc=$response;
        }
        if (strcmp(substr($response,0,3),"500") == 0)
          $desc="-";
      }
      if (strcmp($desc,"") == 0) $desc="-";
      $gruppe->description=$desc;
      fputs($ns,"GROUP ".$gruppe->name."\r\n"); 
      $t=explode(" ",line_read($ns));
      $gruppe->count=$t[1];
      // mark group with new articles with colors
      if($gl_age) {
        fputs($ns,'XOVER '.$t[3]."\r\n");
        $tmp=explode(" ",line_read($ns));
        if($tmp[0]=="224") {
          $tmp=line_read($ns);
          if($tmp!=".") {
            $head=interpretOverviewLine($tmp,$overviewformat,$gruppe->name);
            $tmp=line_read($ns);
            $gruppe->age=$head->date;
          }
        }
      }
      if ((strcmp(trim($gruppe->name),"") != 0) &&
          (substr($gruppe->name,0,1) != "#"))
        $newsgroups[]=$gruppe;
    }
  }
  fclose($gf);
  nntp_close($ns);
  return $newsgroups;
}

/*
 * print the group names from an array to the webpage
 */
function groups_show($gruppen) {
  global $gl_age;
  if ($gruppen == false) return;
  global $file_thread,$text_groups;
  $c = count($gruppen);
  echo "<ul>\n";
  for($i = 0 ; $i < $c ; $i++) {
    $g = $gruppen[$i];
    if(isset($g->text)) {
      echo '</ul>'.$g->text.'<ul>';
    } else {
      echo "<li>";
       echo '<a ';
      if ((isset($frame_threadframeset)) && ($frame_threadframeset != ""))
        echo 'target="'.$frame_threadframeset.'" ';
      echo 'href="'.$file_thread.'?group='.urlencode($g->name).'">'.$g->name."</a>\n";
      if($gl_age)
        $datecolor=format_date_color($g->age);
      echo '<small>(';
      if($datecolor!="")
        echo '<font color="'.$datecolor.'">'.$g->count.'</font>';
      else
        echo $g->count;
      echo ')</small>';
      if($g->description!="-")
        echo '<br><small>'.$g->description.'</small></li>';
    }
    echo "\n";
    flush();
  }
  echo "</ul>\n";
}

/*
 * gets a list of aviable articles in the group $groupname
 */
function getArticleList(&$ns,$groupname) {
  fputs($ns,"LISTGROUP $groupname \r\n");
  $line=line_read($ns);
  $line=line_read($ns);
  while(strcmp($line,".") != 0) {
    $articleList[] = trim($line);
    $line=line_read($ns);
  }
  if (!isset($articleList)) $articleList="-";
  return $articleList;
}

/*
 * Decode quoted-printable or base64 encoded headerlines
 *
 * $value: The to be decoded line
 *
 * returns the decoded line
 */
function headerDecode($value) {
  if (eregi('=\?.*\?.\?.*\?=',$value)) { // is there anything encoded?
    if (eregi('=\?.*\?Q\?.*\?=',$value)) {  // quoted-printable decoding

      $charset=eregi_replace('(.*)=\?(.*)\?Q\?(.*)\?=(.*)','\2',$value);
      $result1=eregi_replace('(.*)=\?.*\?Q\?(.*)\?=(.*)','\1',$value);
      $result2=eregi_replace('(.*)=\?.*\?Q\?(.*)\?=(.*)','\2',$value);
      $result3=eregi_replace('(.*)=\?.*\?Q\?(.*)\?=(.*)','\3',$value);
      $result2=str_replace("_"," ",quoted_printable_decode($result2));
      $newvalue=$result1.recode_charset($result2,$charset).$result3;
    }
    if (eregi('=\?.*\?B\?.*\?=',$value)) {  // base64 decoding
      $result1=eregi_replace('(.*)=\?.*\?B\?(.*)\?=(.*)','\1',$value);
      $result2=eregi_replace('(.*)=\?.*\?B\?(.*)\?=(.*)','\2',$value);
      $result3=eregi_replace('(.*)=\?.*\?B\?(.*)\?=(.*)','\3',$value);
      $result2=base64_decode($result2);
      $newvalue=$result1.$result2.$result3;
    }
    if (!isset($newvalue)) // nothing of the above, must be an unknown encoding...
      $newvalue=$value;
    else
      $newvalue=headerDecode($newvalue);  // maybe there are more encoded
    return($newvalue);                    // parts
  } else {   // there wasn't anything encoded, return the original string
    return($value);
  }
}

/*
 * calculates an Unix timestamp out of a Date-Header in an article
 *
 * $value: Value of the Date: header
 *
 * returns an Unix timestamp
 */
function getTimestamp($value) {
  $months=array("Jan"=>1,"Feb"=>2,"Mar"=>3,"Apr"=>4,"May"=>5,"Jun"=>6,"Jul"=>7,"Aug"=>8,"Sep"=>9,"Oct"=>10,"Nov"=>11,"Dec"=>12);
  $value=str_replace("  "," ",$value);
  $d=split(" ",$value,5);
  if (strcmp(substr($d[0],strlen($d[0])-1,1),",") == 0) {
    $date[0]=$d[1];  // day
    $date[1]=$d[2];  // month
    $date[2]=$d[3];  // year
    $date[3]=$d[4];  // hours:minutes:seconds
  } else {
    $date[0]=$d[0];  // day
    $date[1]=$d[1];  // month
    $date[2]=$d[2];  // year
    $date[3]=$d[3];  // hours:minutes:seconds
  }
  $time=split(":",$date[3]);
  $timestamp=mktime($time[0],$time[1],$time[2],$months[$date[1]],$date[0],$date[2]);
  return $timestamp;
}

function parse_header($hdr,$number="") {
  for ($i=count($hdr)-1; $i>0; $i--)
    if (preg_match("/^(\x09|\x20)/",$hdr[$i]))
      $hdr[$i-1]=$hdr[$i-1]." ".ltrim($hdr[$i]);
  $header = new headerType;
  $header->isAnswer=false;
  for ($count=0;$count<count($hdr);$count++) {
    $variable=substr($hdr[$count],0,strpos($hdr[$count]," "));
    $value=trim(substr($hdr[$count],strpos($hdr[$count]," ")+1));
      switch (strtolower($variable)) {
        case "from:": 
          $fromline=address_decode(headerDecode($value),"nirgendwo");
          if (!isset($fromline[0]["host"])) $fromline[0]["host"]="";
          $header->from=$fromline[0]["mailbox"]."@".$fromline[0]["host"];
          $header->username=$fromline[0]["mailbox"];
          if (!isset($fromline[0]["personal"])) {
            $header->name="";
          } else {
            $header->name=$fromline[0]["personal"];
          }
          break;
        case "message-id:":
          $header->id=$value;
          break;
        case "subject:":
          $header->subject=headerDecode($value);
          break;
        case "newsgroups:":
          $header->newsgroups=$value;
          break;
        case "organization:":
          $header->organization=headerDecode($value);
          break;
        case "content-transfer-encoding:":
          $header->content_transfer_encoding=trim(strtolower($value));
          break; 
        case "content-type:":
          $header->content_type=array();
          $subheader=split(";",$value);
          $header->content_type[0]=strtolower(trim($subheader[0]));
          for ($i=1; $i<count($subheader); $i++) {
            $gleichpos=strpos($subheader[$i],"=");
            if ($gleichpos) {
              $subvariable=trim(substr($subheader[$i],0,$gleichpos));
              $subvalue=trim(substr($subheader[$i],$gleichpos+1));
              if (($subvalue[0]=='"') &&
                  ($subvalue[strlen($subvalue)-1]=='"'))
                $subvalue=substr($subvalue,1,strlen($subvalue)-2);
              switch($subvariable) {
                case "charset":
                  $header->content_type_charset=array(strtolower($subvalue));
                  break;
                case "name":
                  $header->content_type_name=array($subvalue);
                  break;
                case "boundary":
                  $header->content_type_boundary=$subvalue;
                  break;
                case "format":
                  $header->content_type_format=array($subvalue);
              }
            }
          }
          break;
        case "references:":
          $ref=trim($value);
          while (strpos($ref,"> <") != false) {
            $header->references[]=substr($ref,0,strpos($ref," "));
            $ref=substr($ref,strpos($ref,"> <")+2);
          }
          $header->references[]=trim($ref);
          break;
        case "date:":
          $header->date=getTimestamp(trim($value));
          break;
        case "followup-to:":
          $header->followup=trim($value);
          break;
        case "x-newsreader:":
        case "x-mailer:":
        case "user-agent:":
          $header->user_agent=trim($value);
          break;
        case "x-face:": // not ready
//          echo "<p>-".base64_decode($value)."-</p>";
          break;
        case "x-no-archive:":
          $header->xnoarchive=strtolower(trim($value));
      }
  }
  if (!isset($header->content_type[0]))
    $header->content_type[0]="text/plain";
  if (!isset($header->content_transfer_encoding))
    $header->content_transfer_encoding="8bit";
  if ($number != "") $header->number=$number;
  return $header;
}

/*
 * convert the charset of a text
 */
function recode_charset($text,$source=false,$dest=false) {
  global $iconv_enable,$www_charset;
  if($dest==false)
    $dest=$www_charset;
  if(($iconv_enable) && ($source!=false)) {
    $return=iconv($source,
                 $dest."//TRANSLIT",$text);
    if($return!="")
      return $return;
    else
      return $text;
  } else {
    return $text;
  }
}

function decode_body($body,$encoding) {
  $bodyzeile="";
  switch ($encoding) {
    case "base64":
      $body=base64_decode($body);
      break;
    case "quoted-printable":
      $body=Quoted_printable_decode($body);
      $body=str_replace("=\n","",$body);
//    default:
//      $body=str_replace("\n..\n","\n.\n",$body);
  }

  return $body;
}

function message_parse($rawmessage) {
  global $attachment_delete_alternative,$attachment_uudecode,$www_charset;
  global $iconv_enable;
  // Read the header of the message:
  $count_rawmessage=count($rawmessage);
  $message = new messageType;
  $rawheader=array();
  $i=0;
  while ($rawmessage[$i] != "") {
    $rawheader[]=$rawmessage[$i];
    $i++;
  }
  // Parse the Header:
  $message->header=parse_header($rawheader);
  // Now we know if the message is a mime-multipart message:
  $content_type=split("/",$message->header->content_type[0]);
  if ($content_type[0]=="multipart") {
    $message->header->content_type=array();
    // We have multible bodies, so we split the message into its parts
    $boundary="--".$message->header->content_type_boundary;
    // lets find the first part
    while($rawmessage[$i] != $boundary)
      $i++;
    $i++;
    $part=array();
    while($i<=$count_rawmessage) {
      if (($rawmessage[$i]==$boundary) || ($i==$count_rawmessage-1) ||
          ($rawmessage[$i]==$boundary.'--')) {
        $partmessage=message_parse($part);
        // merge the content-types of the message with those of the part
        for ($o=0; $o<count($partmessage->header->content_type); $o++) {
          $message->header->content_type[]=
            $partmessage->header->content_type[$o];
          $message->header->content_type_charset[]=
            $partmessage->header->content_type_charset[$o];
          $message->header->content_type_name[]=
            $partmessage->header->content_type_name[$o];
          $message->header->content_type_format[]=
            $partmessage->header->content_type_format[$o];
          $message->body[]=$partmessage->body[$o];
        }
        $part=array();
      } else {
        if ($i<$count_rawmessage)
          $part[]=$rawmessage[$i];
      }
      if ($rawmessage[$i]==$boundary.'--') break;
      $i++;
    }
    // Is this a multipart/alternative multipart-message? Do we have to
    // delete all non plain/text parts?
    if (($attachment_delete_alternative) &&
        ($content_type[1]=="alternative")) {
      $plaintext=false;
      for ($o=0; $o<count($message->header->content_type); $o++) {
        if ($message->header->content_type[$o]=="text/plain")
          $plaintext=true; // we found at least one text/plain
      }
      if ($plaintext) {    // now we can delete the other parts
        for ($o=0; $o<count($message->header->content_type); $o++) {
          if ($message->header->content_type[$o]!="text/plain") {
            unset($message->header->content_type[$o]);
            unset($message->header->content_type_name[$o]);
            unset($message->header->content_type_charset[$o]);
            unset($message->header->content_type_format[$o]);
            unset($message->body[$o]);
          }
        }
      }
    }
  } else {
    // No mime-attachments in the message:
    $body="";
    $uueatt=0; // as default we have no uuencoded attachments
    for($i++;$i<$count_rawmessage; $i++) {
      // do we have an inlay uuencoded file?
      if ((strtolower(substr($rawmessage[$i],0,5))!="begin") ||
          ($attachment_uudecode==false)) {
        $body.=$rawmessage[$i]."\n";
      // yes, it seems, we have!
      } else {
        $old_i=$i;
        $uue_infoline_raw=$rawmessage[$i];
        $uue_infoline=explode(" ",$uue_infoline_raw);
        $uue_data="";
        $i++;
        while($rawmessage[$i]!="end") {
          if (strlen(trim($rawmessage[$i])) > 2)
            $uue_data.=$rawmessage[$i]."\n";
          $i++;
        }
        // now write the data in an attachment
        $uueatt++;
        $message->body[$uueatt]=uudecode($uue_data);
        $message->header->content_type_name[$uueatt]="";
        for ($o=2; $o<count($uue_infoline); $o++)
          $message->header->content_type_name[$uueatt].=$uue_infoline[$o];
        $message->header->content_type[$uueatt]=
          get_mimetype_by_filename($message->header->content_type_name[$uueatt]);
      }
    }
    if ($message->header->content_type[0]=="text/plain") {
      $body=recode_charset(rtrim($body),
                           $message->header->content_type_charset[0],
                           $www_charset);
      if ($body=="") $body=" ";
      
    }
    $body=decode_body($body,$message->header->content_transfer_encoding);
    $message->body[0]=$body;
  }
    if (!isset($message->header->content_type_charset))
      $message->header->content_type_charset=array($www_charset);
    if (!isset($message->header->content_type_name))
      $message->header->content_type_name=array("unnamed");
    if (!isset($message->header->content_type_format))
      $message->header->content_type_format=array("fixed");
  for ($o=0; $o<count($message->body); $o++) {
    if (!isset($message->header->content_type_charset[$o]))
      $message->header->content_type_charset[$o]=$www_charset;
    if (!isset($message->header->content_type_name[$o]))
      $message->header->content_type_name[$o]="unnamed";
    if (!isset($message->header->content_type_format[$o]))
      $message->header->content_type_format[$o]="fixed";
  }
  return $message;
}


/*
 * remove an article from the overview-file
 * is needed, when article has been canceled, the article is still
 * in the thread spool on disc and someone wants to read this article.
 * the message_read function can now call this function to remove
 * the article now.
 */
function removeArticlefromOverview($group,$id) {
  $thread=loadThreadData($group);
  if(!$thread) return false;
  $changed=false;
  foreach ($thread as $value) {
    if(($value->number==$id) || ($value->id==$id)) {
      // found to be deleted article
      // now lets rebuild the tree...
      if(isset($value->answers))
        foreach ($value->answers as $key => $answer) {
          $thread[$answer]->isAnswer=false;
        }
      if(isset($value->references))
        foreach ($value->references as $reference) {
          if(isset($thread[$reference]->answers)) {
            $search=array_search($value->id,$thread[$reference]->answers);
            if(!($search===false))
              unset($thread[$reference]->answers[$search]);
          }
        }
      unset($thread[$value->id]);
      $changed=true;
      break;
    }
  }
  if($changed) saveThreadData($thread,$group);
}

/*
 * read an article from the newsserver or the spool-directory
 *
 * $id: the Message-ID of an article
 * $bodynum: the number of the attachment:
 *          -1: return only the header without any bodies or attachments.
 *           0: the body
 *           1: the first attachment...
 *
 * The function returns an article as an messageType or false if the article
 * doesn't exists on the newsserver or doesn't contain the given
 * attachment.
 */
function message_read($id,$bodynum=0,$group="") {
  global $cache_articles,$spooldir,$text_error;
  if (!testGroup($group)) {
    echo $text_error["read_access_denied"];
    return;
  }
  $message = new messageType;
  if ((isset($cache_articles)) && ($cache_articles == true)) {
    // Try to load a cached article
    if ((ereg('^[0-9]+$',$id)) && ($group != ''))
      $filename=$group.'_'.$id;
    else
      $filename=base64_encode($id);
    $cachefilename_header=$spooldir."/".$filename.'.header';
    $cachefilename_body=$spooldir."/".$filename.'.body';
    if (file_exists($cachefilename_header)) {
      $cachefile=fopen($cachefilename_header,"r");
      $message->header=unserialize(fread($cachefile,filesize($cachefilename_header)));
      fclose($cachefile);
    } else {
      unset($message->header);
    }
    // Is a non-existing attachment of an article requested?
    if ((isset($message->header)) &&
        ($bodynum!= -1) &&
        (!isset($message->header->content_type[$bodynum])))
      return false;
    if ((file_exists($cachefilename_body.$bodynum)) &&
        ($bodynum != -1)) {
      $cachefile=fopen($cachefilename_body.$bodynum,"r");
      $message->body[$bodynum]=
        fread($cachefile,filesize($cachefilename_body.$bodynum));
      fclose($cachefile);
    }
  }
  if ((!isset($message->header)) ||
      ((!isset($message->body[$bodynum])) &&
       ($bodynum != -1))) {
    if (!isset($ns)) $ns=nntp_open();
    if ($group != "") {
      fputs($ns,"GROUP ".$group."\r\n");
      $line=line_read($ns);
    }
    fputs($ns,'ARTICLE '.$id."\r\n");
    $line=line_read($ns);
    if (substr($line,0,3) != "220") {
      // requested article doesn't exist on the newsserver. Now we
      // should check, if the thread stored in the spool-directory
      // also doesnt't contain that article...
      removeArticlefromOverview($group,$id);
      return false;
    }
    $rawmessage=array();
    $line=line_read($ns);
    while(strcmp($line,".") != 0) {
      $rawmessage[]=$line;
      $line=line_read($ns);
    }
    $message=message_parse($rawmessage);
    if (ereg('^[0-9]+$',$id)) $message->header->number=$id;
    // write header, body and attachments to the cache
    if ((isset($cache_articles)) && ($cache_articles == true)) {
      $cachefile=fopen($cachefilename_header,"w");
      if ($cachefile) {
        fputs($cachefile,serialize($message->header));
      }
      fclose($cachefile);
      for ($i=0; $i<count($message->header->content_type); $i++) {
        if (isset($message->body[$i])) {
          $cachefile=fopen($cachefilename_body.$i,"w");
          fwrite($cachefile,$message->body[$i]);
          fclose($cachefile);
        }
      }
    }
  }
  return $message;
}

function textwrap($text, $wrap=80, $break="\n"){
  $len = strlen($text);
  if ($len > $wrap) {
    $h = '';        // massaged text
    $lastWhite = 0; // position of last whitespace char
    $lastChar = 0;  // position of last char
    $lastBreak = 0; // position of last break
    // while there is text to process
    while ($lastChar < $len) {
      $char = substr($text, $lastChar, 1); // get the next character
      // if we are beyond the wrap boundry and there is a place to break
      if (($lastChar - $lastBreak > $wrap) && ($lastWhite > $lastBreak)) {
        $h .= substr($text, $lastBreak, ($lastWhite - $lastBreak)) . $break;
        $lastChar = $lastWhite + 1;
        $lastBreak = $lastChar;
      }
      // You may wish to include other characters as valid whitespace...
      if ($char == ' ' || $char == chr(13) || $char == chr(10)) {
        $lastWhite = $lastChar; // note the position of the last whitespace
      }
      $lastChar = $lastChar + 1; // advance the last character position by one
    }
    $h .= substr($text, $lastBreak); // build line
  } else {
    $h = $text; // in this case everything can fit on one line
  }
  return $h;
}

/*
 * makes URLs clickable
 *
 * $text: A text-line probably containing links.
 *
 * the function returns the text-line with HTML-Links to the links or
 * email-adresses.
 */
function html_parse($text) {
  global $frame_externallink;
  if ((isset($frame_externallink)) && ($frame_externallink != "")) { 
    $target=' TARGET="'.$frame_externallink.'" ';
  } else {
    $target=' ';
  }
  // regular expressions that will be applied to every word in the text
  $regexp_replace=array(
    'http://([-a-z0-9_./~@?=%#&;+]+)' => 
      '<a'.$target.'href="http://\1">http://\1</a>',
    '(www\.[-a-z]+\.(de|pl|cz|sk|tk|tv|cc|cx|biz|us|uk|info|int|eu|dk|org|net|at|ch|com))' =>
      '<a'.$target.'href="http://\1">\1</a>',
    'https://([-a-z0-9_./~@?=%#&;\n]+)' =>
      '<a'.$target.'href="https://\1">https://\1</a>',
    'gopher://([-a-z0-9_./~@?=%\n]+)' =>
      '<a'.$target.'href="gopher://\1">gopher://\1</a>',
    'news://([-a-z0-9_./~@?=%\n]+)' =>
      '<a'.$target.'href="news://\1">news://\1</a>',
    'ftp://([-a-z0-9_./~@?=%\n]+)' =>
      '<a'.$target.'href="ftp://\1">ftp://\1</a>',
    '([-a-z0-9_./n]+)@([-a-z0-9_.]+)' =>
      '<a href="mailto:\1@\2">\1@\2</a>'
  );
  $ntext="";
  // split every line into it's words
  $words=explode(" ",$text);
  $n=count($words);
  for($i=0; $i<$n; $i++) {
    $word=$words[$i];
    // apply the regular expressions to the word until a matching 
    // expression is found
    foreach ($regexp_replace as $key => $value) {
      $nword=eregi_replace($key,$value,$word);
      if($nword!=$word) {
        $word=$nword;
        break;
      }
    }
    // add the spaces between the words
    if($i>0)
      $ntext.=" ";
    $ntext.=$word;
  }
  return($ntext);
}




/*
 * read the header of an article in plaintext into an array
 * $articleNumber can be the number of an article or its message-id.
 */
function readPlainHeader(&$ns,$group,$articleNumber) {
  fputs($ns,"GROUP $group\r\n");
  $line=line_read($ns);
  fputs($ns,"HEAD $articleNumber\r\n");
  $line=line_read($ns);
  if (substr($line,0,3) != "221") {
    echo $text_error["article_not_found"];
    $header=false;
  } else {
    $line=line_read($ns);
    $body="";
    while(strcmp(trim($line),".") != 0) {
      $body .= $line."\n";
      $line=line_read($ns);
    }
    return split("\n",str_replace("\r\n","\n",$body));
  }
}

function readArticles(&$ns,$groupname,$articleList) {
  for($i = 0; $i <= count($articleList)-1 ; $i++) {
    $temp=read_header($ns,$articleList[$i]);
    $articles[$temp->id] = $temp;
  }
  return $articles;
}

/*
 * Remove re:, aw: etc. from a subject.
 *
 * $subject: a string containing the complete Subject
 *
 * The function removes the re:, aw: etc. from $subject end returns true
 * if it removed anything, and false if not.
 */
function splitSubject(&$subject) {
  $s=eregi_replace('^(odp:|aw:|re:|re\[2\]:| )+','',$subject);
  $return=($s != $subject);
  $subject=$s;
  return $return;
}

function interpretOverviewLine($line,$overviewformat,$groupname) {
  $return="";
  $overviewfmt=explode("\t",$overviewformat);
  echo " ";                // keep the connection to the webbrowser alive
  flush();                 // while generating the message-tree
  $over=split("\t",$line,count($overviewfmt)-1);
  $article=new headerType;
  for ($i=0; $i<count($overviewfmt)-1; $i++) {
    if ($overviewfmt[$i]=="Subject:") {
      $subject=headerDecode($over[$i+1]);
      $article->isReply=splitSubject($subject);
      $article->subject=$subject;
    }
    if ($overviewfmt[$i]=="Date:") {
      $article->date=getTimestamp($over[$i+1]);
    }
    if ($overviewfmt[$i]=="From:") {
      $fromline=address_decode(headerDecode($over[$i+1]),"nirgendwo");
      $article->from=$fromline[0]["mailbox"]."@".$fromline[0]["host"];
      $article->username=$fromline[0]["mailbox"];
      if (!isset($fromline[0]["personal"])) {
        $article->name=$fromline[0]["mailbox"];
        if (strpos($article->name,'%')) {
          $article->name=substr($article->name,0,strpos($article->name,'%'));
        }
        $article->name=strtr($article->name,'_',' ');
      } else {
        $article->name=$fromline[0]["personal"];
      }
    }
    if ($overviewfmt[$i]=="Message-ID:") $article->id=$over[$i+1];
    if (($overviewfmt[$i]=="References:") && ($over[$i+1] != ""))
      $article->references=explode(" ",$over[$i+1]);
  }
  $article->number=$over[0];
  $article->isAnswer=false;
  return($article);
}

/*
 * read the overview-format from the newsserver
 */
function read_overviewformat(&$ns) {
  $overviewfmt=array();
  fputs($ns,"LIST overview.fmt\r\n");  // find out the format of the
  $tmp=line_read($ns);                 // xover-command
  if(substr($tmp,0,3)=="215") {
    $line=line_read($ns);
    while (strcmp($line,".") != 0) {
      $overviewfmt[]=$line;
      $line=line_read($ns);
    }
  } else {
    // some stupid newsservers, like changi, don't send their overview
    // format
    // hope, that the format is like that from INN
    $overviewfmt=array("Subject:","From:","Date:","Message-ID:",
                          "References:","Bytes:");
  }
  $overviewformat=implode("\t",$overviewfmt);
  return $overviewformat;
}

/*
 * Rebuild the Overview-File 
 */
function rebuildOverview(&$ns,$groupname,$poll) {
  global $spooldir,$maxarticles,$maxfetch,$initialfetch,$maxarticles_extra;
  global $text_error,$text_thread,$compress_spoolfiles,$server;
  global $www_charset,$iconv_enable;
  $idstring="0.34,".$server.",".$compress_spoolfiles.",".$maxarticles.",".
            $maxarticles_extra.",".$maxfetch.",".$initialfetch.",".
            $www_charset.','.$iconv_enable;
  $overviewformat=read_overviewformat($ns);
  $spoolfilename=$spooldir."/".$groupname."-data.dat";
  fputs($ns,"GROUP $groupname\r\n");   // select a group
  $groupinfo=explode(" ",line_read($ns));
  if (substr($groupinfo[0],0,1) != 2) {
    echo "<p>".$text_error["error:"]."</p>";
    echo "<p>".$text_thread["no_such_group"]."</p>";
    flush();
  } else {
    $infofilename=$spooldir."/".$groupname."-info.txt";
    // lets find out, in which mode wie want to read articles:
    // w: complete rebuild of the group-info file
    // a: add new articles to the group-info file
    // n: there are no new articles, no rebuild or actualisation
    $spoolopenmodus="n";
    // if the group-info file doesn't exist: create it
    if (!((file_exists($infofilename)) && (file_exists($spoolfilename)))) {
      $spoolopenmodus="w";
    } else {
      $infofile=fopen($infofilename,"r");
      $oldid=fgets($infofile,100);
      if (trim($oldid) != $idstring) {
        echo "<!-- Database Error, rebuilding Database...-->\n";
        $spoolopenmodus="w";
      }
      $oldgroupinfo=explode(" ",trim(fgets($infofile,200)));
      fclose($infofile);
      if ($groupinfo[3] < $oldgroupinfo[1]) {
        $spoolopenmodus="w";
      }
      if ($maxarticles == 0) {
        if ($groupinfo[2] != $oldgroupinfo[0]) $spoolopenmodus="w";
      } else {
        if ($groupinfo[2] > $oldgroupinfo[0]) $spoolopenmodus="w";
      }
      // if the high watermark increased, add articles to the existing spool
      if (($spoolopenmodus == "n") && ($groupinfo[3] > $oldgroupinfo[1]))
        $spoolopenmodus="a";
    }
    if ($spoolopenmodus=="a") {
      $firstarticle=$oldgroupinfo[1]+1;
      $lastarticle=$groupinfo[3];
    }
    if ($spoolopenmodus=="w") {
      $firstarticle=$groupinfo[2];
      $lastarticle=$groupinfo[3];
    }
    if ($spoolopenmodus != "n") {
      if ($maxarticles != 0) {
        if ($spoolopenmodus == "w") {
          $firstarticle=$lastarticle-$maxarticles+1;
          if ($firstarticle < $groupinfo[2])
            $firstarticle=$groupinfo[2];
        } else {
          if ($lastarticle-$oldgroupinfo[0]+1 > $maxarticles + $maxarticles_extra) {
            $firstarticle=$lastarticle-$maxarticles+1;
            $spoolopenmodus="w";
          }
        }
      }
      if (($maxfetch!=0) && (($lastarticle-$firstarticle+1) > $maxfetch)) {
        if ($spoolopenmodus=="w") {
          $tofetch=($initialfetch != 0) ? $initialfetch : $maxfetch;
          $lastarticle=$firstarticle+$tofetch-1;
        } else {
          $lastarticle=$firstarticle+$maxfetch-1;
        }
      }
    }
    echo "<!--openmodus: ".$spoolopenmodus."-->\n";
    // load the old spool-file, if we do not have a complete rebuild
    if ($spoolopenmodus != "w") $headers=loadThreadData($groupname);
    // read articles from the newsserver
    if ($spoolopenmodus != "n") {
      // order the article overviews from the newsserver
      fputs($ns,"XOVER ".$firstarticle."-".$lastarticle."\r\n");
      $tmp=line_read($ns);
      // have the server accepted our order?
      if (substr($tmp,0,3) == "224") {
        $line=line_read($ns);
        // read overview by overview until the data ends
        while ($line != ".") {
          // parse the output of the server...
          $article=interpretOverviewLine($line,$overviewformat,$groupname);
          // ... and save it in our data structure
          $article->threadsize++;
          $article->date_thread=$article->date;
          $headers[$article->id]=$article;
          // if we are in poll-mode: print status information and
          // decode the article itself, so it can be saved in the article
          // cache
          if($poll) {
            echo $article->number.", "; flush();
            message_read($article->number,0,$groupname);
          }
          // read the next line from the newsserver
          $line=line_read($ns);
        }
      }
      // remove the old spoolfile
      if (file_exists($spoolfilename)) unlink($spoolfilename);
      if ((isset($headers)) && (count($headers)>0)) {
        //$infofile=fopen($infofilename,"w");
        //if ($spoolopenmodus=="a") $firstarticle=$oldgroupinfo[0];
        //fputs($infofile,$idstring."\n");
        //fputs($infofile,$firstarticle." ".$lastarticle."\r\n");
        //fclose($infofile);
        foreach($headers as $c) {
          if (($c->isAnswer == false) &&
             (isset($c->references))) {   // is the article an answer to an
                                          // other article?
            // try to find a matching article to one of the references
            $refmatch=false;
            foreach ($c->references as $reference) {
              if(isset($headers[$reference])) {
                $refmatch=$reference;
              }
            }
            // have we found an article, to which this article is an answer?
            if($refmatch!=false) {
              $c->isAnswer=true;
              $c->bestreference=$refmatch;
              $headers[$c->id]=$c;
              // the referenced article get the ID af this article as in
              // its answers-array
              $headers[$refmatch]->answers[]=$c->id;
              // propagate down the number of articles in this thread
              $d =& $headers[$c->bestreference];
              do {
                $d->threadsize+=$c->threadsize;
                $d->date_thread=max($c->date,$d->date_thread);
              } while(($headers[$d->bestreference]) && 
                        (isset($d->bestreference)) &&
                        ($d =& $headers[$d->bestreference]));
            }
          }
        }
        reset($headers);
        // Save the thread-informations
        saveThreadData($headers,$groupname);
        // Save the info-file
        $infofile=fopen($infofilename,"w");
        if ($spoolopenmodus=="a") $firstarticle=$oldgroupinfo[0];
        fputs($infofile,$idstring."\n");
        fputs($infofile,$firstarticle." ".$lastarticle."\r\n");
        fclose($infofile);
      }
      // remove cached articles that are not in this group
      // (expired on the server or canceled)
      $dirhandle=opendir($spooldir);
      while ($cachefile = readdir($dirhandle)) {
        if(substr($cachefile,0,strlen($groupname)+1)==$groupname."_") {
          $num=eregi_replace('^(.*)_(.*)\.(.*)$','\2',$cachefile);
          if(($num<$firstarticle) || ($num>$lastarticle))
            unlink($spooldir.'/'.$cachefile);
        }
        // remove the html cache files of this group
        if((substr($cachefile,strlen($cachefile)-5)==".html") &&
           (substr($cachefile,0,strlen($groupname)+1)==$groupname."-"))
          unlink($spooldir.'/'.$cachefile);
      }
    }
    return((isset($headers)) ? $headers : false);
  }
}  


/*
 * Read the Overview.
 * Format of the overview-file:
 *    message-id
 *    date
 *    subject
 *    author
 *    email
 *    references
 */
  function mycompare($a,$b) {
    global $thread_sort_order,$thread_sort_type;
    if($thread_sort_type!="thread") {
      $r=($a->date<$b->date) ? -1 : 1;
      if ($a->date==$b->date) $r=0;
    } else {
      $r=($a->date_thread<$b->date_thread) ? -1 : 1;
      if ($a->date_thread==$b->date_thread) $r=0;
    }
    return $r*$thread_sort_order;
  }
function readOverview(&$ns,$groupname,$readmode = 1,$poll=false) {
  global $text_error, $maxarticles;
  global $spooldir,$thread_sort_order;
  if (!testGroup($groupname)) {
    echo $text_error["read_access_denied"];
    return;
  }
  if ($ns == false) return false;
  if (($ns!=false) && ($readmode > 0)) 
    $articles=rebuildOverview($ns,$groupname,$poll);
  if ((isset($articles)) && ($articles)) {
    if (($thread_sort_order != 0) && (count($articles)>0))
      uasort($articles,'mycompare');
    return $articles;
  } else {
    return false;
  }
}

function str_change($str,$pos,$char) {
  return(substr($str,0,$pos).$char.substr($str,$pos+1,strlen($str)-$pos));
}

function format_date_color($date) {
  global $age_count,$age_time,$age_color;
  $return="";
  $currentTime=time();
  if ($age_count > 0)
    for($t = $age_count; $t >= 1; $t--) {
      if ($currentTime - $date < $age_time[$t])
        $color = $age_color[$t];
    }
  if (isset($color))
    return $color;
  else
    return "";
}

function formatDate($c) {
  global $age_count,$age_time,$age_color;
  $return="";
  $currentTime=time();
  $color="";
  if ($age_count > 0)
    for($t = $age_count; $t >= 1; $t--)
      if ($currentTime - $c->date < $age_time[$t]) $color = $age_color[$t];
  if ($color != "") $return .= '<font color="'.$color.'">';
  $return .= date("d.m.",$c->date);                 // format the date
  if ($color != "") $return .= '</font>';
  return($return);
}

function calculateTree($newtree,$depth,$num,$liste,$c) {
  if ((isset($c->answers[0])) && (count($c->answers)>0)) {
    $newtree.="*";
  } else {
    if ($depth == 1) {
      $newtree.="o";
    } else {
      $newtree.="-";
    }
  }
  if (($num == count($liste)-1) && ($depth>1)) {
    $newtree=str_change($newtree,$depth-2,"`");
  }
  return($newtree);
}


/*
 * Format the message-tree
 * Zeichen im Baum:
 *  o : leerer Kasten            k1.gif
 *  * : Kasten mit Zeichen drin  k2.gif
 *  i : vertikale Linie          I.gif
 *  - : horizontale Linie        s.gif
 *  + : T-Stueck                 T.gif
 *  ` : Winkel                   L.gif
 */
function formatTreeGraphic($newtree) {
  global $imgdir;
  $return="";
  for ($o=0 ; $o<strlen($newtree) ; $o++) {
    $return .= '<img src="'.$imgdir.'/';
    $k=substr($newtree,$o,1);
    $alt=$k;
    switch ($k) {
      case "o":
        $return .= 'k1.gif';
        break;
      case "*":
        $return .= 'k2.gif';
        break;
      case "i":
        $return .= 'I.gif';
        $alt='|';
        break;
      case "-":
        $return .= 's.gif';
        break;
      case "+":
        $return .= 'T.gif';
        break;
      case "`":
        $return .= 'L.gif';
        break;
      case ".":
        $return .= 'e.gif';
        $alt='&nbsp;';
        break;
      }
    $return .= '" alt="'.$alt.'" class="thread_image"';
    if (strcmp($k,".") == 0) $return .=(' width="12" height="9"');
    $return .= '>';
  }
  return($return);
}

function formatTreeText($tree) {
  $tree=str_replace("i","|",$tree);
  $tree=str_replace(".","&nbsp;",$tree);
  return($tree);
}

function formatSubject($c,$group,$highlight=false) {
  global $file_article, $thread_maxSubject, $frame_article;
  if ($c->isReply) {
    $re="Re: ";
  } else {
    $re="";
  }
  if($highlight==$c->id)
    $return='<b>';
  else {
    $return='<a ';
    if ((isset($frame_article)) && ($frame_article != ""))
      $return .= 'target="'.$frame_article.'" ';
    $return .= 'href="'.$file_article.
       '?id='.urlencode($c->number).'&group='.urlencode($group).'">';
  }
  $return.=$re.htmlspecialchars(substr(trim($c->subject),0,$thread_maxSubject));
  if($highlight==$c->id)
    $return.='</b>';
  else
    $return.='</a>';
  return($return);
}

function formatAuthor($c) {
  global $thread_show_authorlink;
  $return="";
  if($thread_show_authorlink)
    $return .= '<a href="mailto:'.trim($c->from).'">';
  if (trim($c->name)!="") { 
    $return .= htmlspecialchars(trim($c->name));
  } else {
    if (isset($c->username)) {
      $s = strpos($c->username,"%");
      if ($s != false) {
        $return .= htmlspecialchars(substr($c->username,0,$s));
      } else {
        $return .= htmlspecialchars($c->username);
      }
    }
  }
  if($thread_show_authorlink)
    $return .= "</a>";
  return($return);
}

/*
 * Displays a part of the thread. This function is recursively called
 * It is used by showHeaders
 */
function showThread(&$headers,&$liste,$depth,$tree,$group,$article_first=0,$article_last=0,&$article_count,$highlight=false) {
  global $thread_treestyle;
  global $thread_show_date,$thread_show_subject;
  global $thread_show_author,$imgdir;
  global $file_article,$thread_maxSubject;
  global $age_count,$age_time,$age_color;
  global $frame_article;
  $output="";
  if ($thread_treestyle==3) $output.= "\n<UL>\n";
  for ($i = 0 ; $i<count($liste) ; $i++) {
    // CSS class for the actual line
    $lineclass="np_thread_line".(($article_count%2)+1);
    // read the first article
    $c=$headers[$liste[$i]]; 
    $article_count++; 
    // Render the graphical tree
    switch ($thread_treestyle) {
      case 4:  // thread
      case 5:  // thread, graphic
      case 6:  // thread, table
      case 7:  // thread, table, graphic
        $newtree=calculateTree($tree,$depth,$i,$liste,$c);
    }
    if (($article_first == 0) ||
        (($article_count >= $article_first) &&
         ($article_count <= $article_last))) {
      switch ($thread_treestyle) {
        case 0: // simple list
          $output.= '<span class="np_thread_line_text">';
          if ($thread_show_date) $output.= formatDate($c)." ";
          if ($thread_show_subject) $output.= formatSubject($c,$group)." ";
          if ($thread_show_author) $output.= "(".formatAuthor($c).")";
          $output.= '</span>';
          $output.= "<br>\n";
          break;
        case 1: // html-auflistung, kein baum
          $output.= '<li><nobr><span class="np_thread_line_text">';
          if ($thread_show_date)
            $output.= formatDate($c).' ';
          if ($thread_show_subject)
            $output.= formatSubject($c,$group,$highlight).' ';
          if ($thread_show_author)
            $output.= "<i>(".formatAuthor($c).")</i>";
          $output.= '</span></nobr></li>';
          break;
        case 2:   // table
          $output.= '<tr>';
          if ($thread_show_date) {
            $output.= '<td><span class="np_thread_line_text">'.
                      formatDate($c).' </span></td>';
          }
          if ($thread_show_subject) {
            $output.= '<td nowrap="nowrap">'.
                 '<span class="np_thread_line_text">'.
                 formatSubject($c,$group,$highlight).
                 '</span></td>';
          }
          if ($thread_show_author) {
            $output.= '<td></td>'.
                      '<td nowrap="nowrap">'.
                      '<span class="np_thread_line_text">'.formatAuthor($c).
                      '</span></td>';
          }
          $output.= "</tr>\n";
          break;
        case 3: // html-tree
          $output.= '<li><nobr><span class="np_thread_line_text">';
          if ($thread_show_date)
            $output.= formatDate($c)." ";
          if ($thread_show_subject)
            $output.= formatSubject($c,$group,$highlight)." ";
          if ($thread_show_author)
            $output.= "<i>(".formatAuthor($c).")</i>";
          $output.= "</span></nobr>";
          break;
        case 4:  // thread
          $output.= '<nobr><tt><span class="np_thread_line_text">';
          if ($thread_show_date)
            $output.= formatDate($c)." ";
          $output.= formatTreeText($newtree)." ";
          if ($thread_show_subject)
            $output.= formatSubject($c,$group,$highlight)." ";
          if ($thread_show_author)
            $output.= "<i>(".formatAuthor($c).")</i>";
          $output.= '</span></tt></nobr><br>';
          break;
        case 5:  // thread, graphic
          $output.= '<table cellspacing="0"><tr>';
          if ($thread_show_date)
            $output.= '<td nowrap="nowrap">'.
                      '<span class="np_thread_line_text">'.
                      formatDate($c).' </span></td>';
          $output.= '<td><span class="np_thread_line_text">'.
                    formatTreeGraphic($newtree).'</span></td>';
          if ($thread_show_subject)
            $output.= '<td nowrap="nowrap">'.
                      '<span class="np_thread_line_text">&nbsp;'.
                      formatSubject($c,$group,$highlight)." ";
          if ($thread_show_author)
            $output.= '('.formatAuthor($c).')</span></td>';
          $output.= "</tr></table>";
          break;
        case 6:  // thread, table
          $output.= "<tr>";
          if ($thread_show_date)
            $output.= '<td nowrap="nowrap"><tt>'.
                      '<span class="np_thread_line_text">'.
                      formatDate($c).' </span></tt></td>';
          $output.= '<td nowrap="nowrap"><tt>'.
                    '<span class="np_thread_line_text">'.
                    formatTreeText($newtree)." ";
          if ($thread_show_subject) {
            $output.= formatSubject($c,$group,$highlight)."</span></tt></td>";
            $output.= "<td></td>";
          }
          if ($thread_show_author)
            $output.= '<td nowrap="nowrap"><tt>'.
                      '<span class="np_thread_line_text">'.
                      formatAuthor($c).'</span></tt></td>';
          $output.= "</tr>";
          break;
        case 7:  // thread, table, graphic
          $output.= '<tr class="'.$lineclass;
          $output.='">';
          if ($thread_show_date)
            $output.= '<td class="'.$lineclass.'" nowrap="nowrap">'.
                      '<span class="np_thread_line_text">'.formatDate($c)." ".
                      '</span></td>';
            $output.= '<td nowrap class="'.$lineclass.'">';
            $output.= formatTreeGraphic($newtree);
            if ($thread_show_subject)
              $output.= '<span class="np_thread_line_text">&nbsp;'.
                formatSubject($c,$group,$highlight).'</span>';
            $output.='</td>';
            if ($thread_show_subject) $output.= "<td></td>";
            if ($thread_show_author)
              $output.= '<td class="'.$lineclass.'" nowrap="nowrap">'.
                      '<span class="np_thread_line_text">'.
                      formatAuthor($c).'</span></td>';
            // test
            //$output.= "<td>".$c->threadsize.'</td>';
            $output.= "</tr>";
            break;
      }
    }
    if ((isset($c->answers[0])) && (count($c->answers)>0) &&
        ($article_count<=$article_last)) {
      if ($thread_treestyle >= 4) {
        if (substr($newtree,$depth-2,1) == "+")
          $newtree=str_change($newtree,$depth-2,"i");
        $newtree=str_change($newtree,$depth-1,"+");
        $newtree=strtr($newtree,"`",".");
      }
      if (!isset($newtree)) $newtree="";
      $output.=showThread($headers,$c->answers,$depth+1,$newtree."",$group,
                 $article_first,$article_last,$article_count,$highlight);
    }
    flush();
  }
  if ($thread_treestyle==3) $output.= "</UL>";
  return $output;
}

/*
 * Displays a Thread. Is used in article.php
 *
 * $id:    Message-ID (not number!) of an article in the thread
 * $group: name of the newsgroup
 */
function message_thread($id,$group,$thread) {
  $current=$id;
  flush();
  echo "<hr>";
  while(isset($thread[$id]->references)) {
    foreach($thread[$id]->references as $reference) {
      if((trim($reference)!='') && (isset($thread[$reference]))) {
        $id=$reference;
        continue 2;
      }
    }
    break;
  }
  $liste=array();
  $liste[]=$id;
  $tmp=0;
  showHeaders_head();
  echo showThread($thread,$liste,1,"",$group,0,100,$tmp,$current);
  showHeaders_tail();
}

/*
 * Load a thread from disk
 *
 * $group: name of the newsgroup, is needed to create the filename
 * 
 * the function returns an array of headerType containing the 
 * overview-data of the thread.
 */
function loadThreadData($group) {
  global $spooldir,$compress_spoolfiles;
  $filename=$spooldir."/".$group."-data.dat";
  if (!file_exists($filename)) return false;
  if ($compress_spoolfiles) {
    $file=gzopen("$spooldir/$group-data.dat","r");
    $headers=unserialize(gzread($file,1000000));
    gzclose($file);
  } else {
    $file=fopen($filename,"r");
    $headers=unserialize(fread($file,filesize($filename)));
    fclose($file);
  }
  return($headers);
}


/*
 * Save the thread to disk
 *
 * $header: is an array of headerType containing all overview-information
 *          of a newsgroup
 * $group: name of the newsgroup, is needed to create the filename
 */
function saveThreadData($headers,$group) {
  global $spooldir,$compress_spoolfiles;
  if ($compress_spoolfiles) {
    $file=gzopen("$spooldir/$group-data.dat","w");
    gzputs($file,serialize($headers));
    gzclose($file);
  } else {
    $file=fopen("$spooldir/$group-data.dat","w");
    if($file===false) {
      die('The spool-directory is not writeable. Please change the user '.
          'permissions to give the webserver write-access to it.');
    }
    fputs($file,serialize($headers));
    fclose($file);
  }
}

/*
 * Displays the Head (table tags, headlines etc.) of a thread
 */
function showHeaders_head() {
  global $thread_show_date, $thread_showTable;
  global $thread_show_author,$thread_show_subject;
  global $text_thread,$thread_treestyle;
  if (($thread_treestyle==2) || ($thread_treestyle==6) ||
      ($thread_treestyle==7)) {
    echo '<table cellspacing="0" class="np_thread_table">';
    echo '<tr class="np_thread_head">'."\n";
    if ($thread_show_date)
      echo '<td width="1%" class="np_thread_head">'.$text_thread["date"]."&nbsp;</td>";
    if ($thread_show_subject)
      echo '<td class="np_thread_head">'.
           $text_thread["subject"]."</td>";
    if ($thread_show_author) {
      echo '<td class="np_thread_head">&nbsp;&nbsp;</td>';
      echo '<td class="np_thread_head">'.$text_thread["author"]."</td>\n";
    }
    echo "</tr>\n";
  } else {
    if ($thread_treestyle==1) echo "<ul>\n";
  }
}

/*
 * Displays the tail (closing table tags, headlines etc.) of a thread
 */
function showHeaders_tail() {
  global $thread_show_date, $thread_showTable;
  global $thread_show_author,$thread_show_subject;
  global $text_thread,$thread_treestyle;
  if (($thread_treestyle==2) || ($thread_treestyle==6) ||
      ($thread_treestyle==7)) {
    echo "</table>\n";
  } else {
    if ($thread_treestyle==1) echo "</ul>\n";
  }
}

/*
 * Shows a complete thread
 *
 * $headers: The thread to be displayed
 * $group:   name of the newsgroup
 * $article_first: Number of the first article to be displayed
 * $article_last: last article
 */
function showHeaders(&$headers,$group,$article_first=0,$article_last=0) {
  global $spooldir,$text_thread;
  $article_count=0;
  if ($headers == false) {
    echo $text_thread["no_articles"];
  } else {
    // exists a cached html-output?
    $filename=$spooldir."/".$group."-".$article_first."-".
              $article_last.".html";
    if (!file_exists($filename)) {
      // no, we need to create a new html-output
      $output="";
      reset($headers);
      $c=current($headers);
      for ($i=0; $i<=count($headers)-1; $i++) {  // create the array $liste
        if ($c->isAnswer == false) {             // where are all the articles
          $liste[]=$c->id;                       // in that don't have
        }                                        // references
        $c=next($headers);
      }
      reset($liste);
      if (count($liste)>0) {
        $output.=showThread($headers,$liste,1,"",$group,$article_first,
                 $article_last,$article_count);
      }
      // cache the html-output
      $file=fopen($filename,"w");
      fputs($file,$output);
      fclose($file);
    } else {
      // yes, a cached output exists, load it!
      $file=fopen($filename,"r");
      $output=fread($file,filesize($filename));
      fclose($file);
    }
    showHeaders_head();
    echo $output;
    showHeaders_tail();
  }
}


/*
 * Print the header of a message to the webpage
 *
 * $head: the header of the message as an headerType
 * $group: the name of the newsgroup, is needed for the links to post.php3
 *         and the header.
 */
function show_header($head,$group) {
  global $article_show,$text_header,$file_article,$attachment_show;
  global $file_attachment;
  echo '<div class="np_article_header">';
  if ($article_show["Subject"]) echo $text_header["subject"].htmlspecialchars($head->subject)."<br>";
  if ($article_show["From"]) {
    echo $text_header["from"];
    if($article_show["From_link"])
      echo '<a href="mailto:'.htmlspecialchars($head->from).'">';
    if(isset($article_show["From_rewrite"]))
      echo htmlspecialchars(eregi_replace($article_show["From_rewrite"][0],
                              $article_show["From_rewrite"][1],$head->from));
    else
      echo htmlspecialchars($head->from);
    if($article_show["From_link"])
      echo '</a>';
    if ($head->name != "") echo ' ('.htmlspecialchars($head->name).')';
    echo "<br>";
  }
  if ($article_show["Newsgroups"]) 
    echo $text_header["newsgroups"].htmlspecialchars(str_replace(',',', ',$head->newsgroups))."<br>\n";
  if (isset($head->followup) && ($article_show["Followup"]) && ($head->followup != "")) 
    echo $text_header["followup"].htmlspecialchars($head->followup)."<br>\n";
  if ((isset($head->organization)) && ($article_show["Organization"]) &&
     ($head->organization != ""))
    echo $text_header["organization"].
         html_parse(htmlspecialchars($head->organization))."<br>\n";
  if ($article_show["Date"])
    echo $text_header["date"].date($text_header["date_format"],$head->date)."<br>\n";
  if ($article_show["Message-ID"])
    echo $text_header["message-id"].htmlspecialchars($head->id)."<br>\n";
  if (($article_show["References"]) && (isset($head->references[0]))) {
    echo $text_header["references"];
    for ($i=0; $i<=count($head->references)-1; $i++) {
      $ref=$head->references[$i];
      echo ' '.'<a href="'.$file_article.'?group='.urlencode($group).
           '&id='.urlencode($ref).'">'.($i+1).'</a>';
    }
    echo "<br>";
  }
  if (isset($head->user_agent)) {
    if ((isset($article_show["User-Agent"])) &&
       ($article_show["User-Agent"])) {
      echo $text_header["user-agent"].htmlspecialchars($head->user_agent)."<br>\n";
    } else {
      echo "<!-- User-Agent: ".htmlspecialchars($head->user_agent)." -->\n";
    }
  }
  if ((isset($attachment_show)) && ($attachment_show==true) &&
      (isset($head->content_type[1]))) {
    echo $text_header["attachments"];
    for ($i=1; $i<count($head->content_type); $i++) {
      echo '<a href="'.$file_attachment.'?group='.urlencode($group).'&'.
           'id='.urlencode($head->number).'&'.
           'attachment='.$i.'">'.
           $head->content_type_name[$i].'</a> ('.
           $head->content_type[$i].')';
      if ($i<count($head->content_type)-1) echo ', ';
    }
  }
  echo '</div>';
}

/*
 * decodes a body. Splits the content of $body into an array of several
 * lines, respecting the special decoding issues of format=flowed
 * articles. Each returned line consists of two fields: text and
 * the quote depth (depth)
 */
function decode_textbody($body,$format="fixed") {
  $body=split("\n",$body);
  $nbody=array();
  $depth=0;
  $paragraph=""; // empty paragraph
  $lastline="";
  for($i=0; $i<count($body)+1; $i++) {
    // calculate the quote depth of the actual line
    $ndepth=0;
    $tdepth=0;
    for($j=0; $j<=strlen($body[$i]); $j++) {
      $tdepth=$j;
      if($body[$i][$j]=='>') {
        $ndepth++;
      } else {
        if(($body[$i][$j]!=' ') || ($body[$i][$j-1]==' ') || ($j==0)) {
          break;
        }
      }
    }
    // generate a new paragraph?
    if(($i>0) && (($ndepth!=$depth) || $format!="flowed" ||
       ($paragraph[strlen($paragraph)-1]!=' ')) || ($i==count($body))) {
      $tmp->text=$lastline=$paragraph;
      $tmp->depth=$depth;
      $paragraph="";
      $nbody[]=$tmp;
    }
    if($body[$i]=="-- " && $format=="flowed") $body[$i]="--";
    $paragraph.=substr($body[$i],$tdepth);
    $depth=$ndepth;
  }
  return $nbody;
}

/*
 * replaces multiple spaces in texts by &nbsp;es and convert special-chars
 * to their entities
 */
function text2html($text) {
  return eregi_replace("^ ","&nbsp;",
         str_replace("  ","&nbsp; ",
         str_replace("  ","&nbsp; ",
         str_replace("\n","<br>",
         htmlspecialchars($text)))));
}


/*
 * print an article to the webpage
 *
 * $group: The name of the newsgroup
 * $id: the ID of the article inside the group or the message-id
 * $attachment: The number of the attachment of the article.
 *              0 means the normal textbody.
 */
function message_show($group,$id,$attachment=0,$article_data=false) {
  global $file_article;
  global $text_header,$text_article,$article_showthread;
  global $block_xnoarchive,$article_graphicquotes;
  if ($article_data == false)
    $article_data=message_read($id,$attachment,$group);
  $head=$article_data->header;
  $body=$article_data->body[$attachment];
  if ($head) {
    if (($block_xnoarchive) && (isset($head->xnoarchive)) &&
        ($head->xnoarchive=="yes")) {
      echo $text_article["block-xnoarchive"];
    } else
    if (($head->content_type[$attachment]=="text/plain") &&
        ($attachment==0)) {
      show_header($head,$group);
      echo '<br>';
      $body=decode_textbody($body,
             $article_data->header->content_type_format[$attachment]);
      $depth=0;
      for ($i=0; $i<=count($body); $i++) {
        // HTMLized Quotings instead of boring > ?
        if($article_graphicquotes) {
          // HTMLized Quotings
          for($j=$depth; $j<$body[$i]->depth; $j++)
            echo '<blockquote class="np_article_quote">';
          for($j=$body[$i]->depth; $j<$depth; $j++)
            echo '</blockquote>';
          echo '<tt class="np_article_text">';
          echo html_parse(text2html($body[$i]->text)).'</tt><br>';
          echo "\n";
          $depth=$body[$i]->depth;
        } else {
          // Boring old Quotings with >
          if($body[$i]->depth==0) {
            if(trim($body[$i]->text)=='')
              echo "<br>\n";
            else
              echo '<tt class="np_article_text">'.
                   html_parse(text2html($body[$i]->text))."</tt><br>\n";
          } else {
            echo '<tt class="np_article_text"><i>'.str_repeat('&gt;',$body[$i]->depth).' '.
              html_parse(text2html(
                 textwrap($body[$i]->text,72-$body[$i]->depth,
                  "\n".str_repeat('>',$body[$i]->depth).' '))).
              "</i></tt><br>\n";
          }
        }
      }
    } else {
      echo $body;
    }
  }
}

/*
 * Encode lines with 8bit-characters to quote-printable
 *
 * $line: the to be encoded line
 *
 * the function returns a sting containing the quoted-printable encoded
 * $line
 */
function quoted_printable_encode($line) {
  global $www_charset;
  $qp_table=array(
     '=00', '=01', '=02', '=03', '=04', '=05',
     '=06', '=07', '=08', '=09', '=0A', '=0B',
     '=0C', '=0D', '=0E', '=0F', '=10', '=11',
     '=12', '=13', '=14', '=15', '=16', '=17',
     '=18', '=19', '=1A', '=1B', '=1C', '=1D',
     '=1E', '=1F', '_',   '!',   '"',   '#',
     '$',   '%',   '&',   "'",   '(',   ')',
     '*',   '+',   ',',   '-',   '.',   '/',
     '0',   '1',   '2',   '3',   '4',   '5',
     '6',   '7',   '8',   '9',   ':',   ';',
     '<',   '=3D', '>',   '=3F', '@',   'A',
     'B',   'C',   'D',   'E',   'F',   'G',
     'H',   'I',   'J',   'K',   'L',   'M',
     'N',   'O',   'P',   'Q',   'R',   'S',
     'T',   'U',   'V',   'W',   'X',   'Y',
     'Z',   '[',   '\\',  ']',   '^',   '=5F',
     '',    'a',   'b',   'c',   'd',   'e',
     'f',   'g',   'h',   'i',   'j',   'k',
     'l',   'm',   'n',   'o',   'p',   'q',
     'r',   's',   't',   'u',   'v',   'w',
     'x',   'y',   'z',   '{',   '|',   '}',
     '~',   '=7F', '=80', '=81', '=82', '=83',
     '=84', '=85', '=86', '=87', '=88', '=89',
     '=8A', '=8B', '=8C', '=8D', '=8E', '=8F',
     '=90', '=91', '=92', '=93', '=94', '=95',
     '=96', '=97', '=98', '=99', '=9A', '=9B',
     '=9C', '=9D', '=9E', '=9F', '=A0', '=A1',
     '=A2', '=A3', '=A4', '=A5', '=A6', '=A7',
     '=A8', '=A9', '=AA', '=AB', '=AC', '=AD',
     '=AE', '=AF', '=B0', '=B1', '=B2', '=B3',
     '=B4', '=B5', '=B6', '=B7', '=B8', '=B9',
     '=BA', '=BB', '=BC', '=BD', '=BE', '=BF',
     '=C0', '=C1', '=C2', '=C3', '=C4', '=C5',
     '=C6', '=C7', '=C8', '=C9', '=CA', '=CB',
     '=CC', '=CD', '=CE', '=CF', '=D0', '=D1',
     '=D2', '=D3', '=D4', '=D5', '=D6', '=D7',
     '=D8', '=D9', '=DA', '=DB', '=DC', '=DD',
     '=DE', '=DF', '=E0', '=E1', '=E2', '=E3',
     '=E4', '=E5', '=E6', '=E7', '=E8', '=E9',
     '=EA', '=EB', '=EC', '=ED', '=EE', '=EF',
     '=F0', '=F1', '=F2', '=F3', '=F4', '=F5',
     '=F6', '=F7', '=F8', '=F9', '=FA', '=FB',
     '=FC', '=FD', '=FE', '=FF');
  // are there "forbidden" characters in the string?
  for($i=0; $i<strlen($line) && ord($line[$i])<=127 ; $i++);
  if ($i<strlen($line)) { // yes, there are. So lets encode them!
    $from=$i;
    for($to=strlen($line)-1; ord($line[$to])<=127; $to--);
    // lets scan for the start and the end of the to be encoded _words_
    for(;$from>0 && $line[$from] != ' '; $from--);
    if($from>0) $from++;
    for(;$to<strlen($line) && $line[$to] != ' '; $to++);
    // split the string into the to be encoded middle and the rest
    $begin=substr($line,0,$from);
    $middle=substr($line,$from,$to-$from);
    $end=substr($line,$to);
    // ok, now lets encode $middle...
    $newmiddle="";
    for($i=0; $i<strlen($middle); $i++)
      $newmiddle .= $qp_table[ord($middle[$i])];
    // now we glue the parts together...
    $line=$begin.'=?'.$www_charset.'?Q?'.$newmiddle.'?='.$end;
  }
  return $line;
}

/*
 * Post an article to a newsgroup
 *
 * $subject: The Subject of the article
 * $from: The authors name and email of the article
 * $newsgroups: The groups to post to
 * $ref: The references of the article
 * $body: The article itself
 */
function message_post($subject,$from,$newsgroups,$ref,$body) {
  global $server,$port,$send_poster_host,$organization,$text_error;
  global $file_footer,$www_charset;
  flush();
  $ns=nntp_open($server,$port);
  if ($ns != false) {
    fputs($ns,"POST\r\n");
    $weg=line_read($ns);
    fputs($ns,'Subject: '.quoted_printable_encode($subject)."\r\n");
    fputs($ns,'From: '.$from."\r\n");
    fputs($ns,'Newsgroups: '.$newsgroups."\r\n");
    fputs($ns,"Mime-Version: 1.0\r\n");
    fputs($ns,"Content-Type: text/plain; charset=".$www_charset."; format=flowed\r\n");
    fputs($ns,"Content-Transfer-Encoding: 8bit\r\n");
    fputs($ns,"User-Agent: NewsPortal/0.34 (http://florian-amrhein.de/newsportal/)\r\n");
    if ($send_poster_host)
      @fputs($ns,'X-HTTP-Posting-Host: '.gethostbyaddr(getenv("REMOTE_ADDR"))."\r\n");
    if (($ref!=false) && (count($ref)>0)) {
      // strip references
      if(strlen(implode(" ",$ref))>900) {
        $ref_first=array_shift($ref);
        do {
          $ref=array_slice($ref,1);
        } while(strlen(implode(" ",$ref))>800);
        array_unshift($ref,$ref_first);
      }
      fputs($ns,'References: '.implode(" ",$ref)."\r\n");
    }
    if (isset($organization))
      fputs($ns,'Organization: '.quoted_printable_encode($organization)."\r\n");
    if ((isset($file_footer)) && ($file_footer!="")) {
      $footerfile=fopen($file_footer,"r");
      $body.="\n".fread($footerfile,filesize($file_footer));
      fclose($footerfile);
    }
    $body=str_replace("\n.\r","\n..\r",$body);
    $body=str_replace("\r",'',$body);
    $b=split("\n",$body);
    $body="";
    for ($i=0; $i<count($b); $i++) {
      if ((strpos(substr($b[$i],0,strpos($b[$i]," ")),">") != false) | (strcmp(substr($b[$i],0,1),">") == 0)) {
        $body .= textwrap(stripSlashes($b[$i]),78," \r\n")."\r\n";
      } else {
        $body .= textwrap(stripSlashes($b[$i]),74," \r\n")."\r\n";
      }
    }
    fputs($ns,"\r\n".$body."\r\n.\r\n");
    $message=line_read($ns);
    nntp_close($ns);
  } else {
    $message=$text_error["post_failed"];
  }
  return $message;
}


/*
 * cancel an article on the newsserver
 *
 * DO NOT USE THIS FUNCTION, IF YOU DON'T KNOW WHAT YOU ARE DOING!
 *
 * $ns: The handler of the NNTP-Connection
 * $group: The group of the article
 * $id: the Number of the article inside the group or the message-id
 */
function message_cancel($subject,$from,$newsgroups,$ref,$body,$id) {
  global $server,$port,$send_poster_host,$organization,$text_error;
  global $file_footer,$www_charset;
  flush();
  $ns=nntp_open($server,$port);
  if ($ns != false) {
    fputs($ns,"POST\r\n");
    $weg=line_read($ns);
    fputs($ns,'Subject: '.quoted_printable_encode($subject)."\r\n");
    fputs($ns,'From: '.$from."\r\n");
    fputs($ns,'Newsgroups: '.$newsgroups."\r\n");
    fputs($ns,"Mime-Version: 1.0\r\n");
    fputs($ns,"Content-Type: text/plain; charset=".$www_charset."\r\n");
    fputs($ns,"Content-Transfer-Encoding: 8bit\r\n");
    if ($send_poster_host)
      fputs($ns,'X-HTTP-Posting-Host: '.gethostbyaddr(getenv("REMOTE_ADDR"))."\r\n");
    if ($ref!=false) fputs($ns,'References: '.$ref."\r\n");
    if (isset($organization))
      fputs($ns,'Organization: '.quoted_printable_encode($organization)."\r\n");
    fputs($ns,"Control: cancel ".$id."\r\n");
    if ((isset($file_footer)) && ($file_footer!="")) {
      $footerfile=fopen($file_footer,"r");
      $body.="\n".fread($footerfile,filesize($file_footer));
      fclose($footerfile);
    }
    $body=str_replace("\n.\r","\n..\r",$body);
    $body=str_replace("\r",'',$body);
    $b=split("\n",$body);
    $body="";
    for ($i=0; $i<count($b); $i++) {
      if ((strpos(substr($b[$i],0,strpos($b[$i]," ")),">") != false ) | (strcmp(substr($b[$i],0,1),">") == 0)) {
        $body .= textwrap(stripSlashes($b[$i]),78,"\r\n")."\r\n";
      } else {
        $body .= textwrap(stripSlashes($b[$i]),74,"\r\n")."\r\n";
      }
    }
    fputs($ns,"\r\n".$body."\r\n.\r\n");
    $message=line_read($ns);
    nntp_close($ns);
  } else {
    $message=$text_error["post_failed"];
  }
  return $message;
}

?>